"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var attributeName = 'ant-click-animating-without-extra-node';
var styleForPesudo;
function isNotGrey(color) {
    var match = (color || '').match(/rgba?\((\d*), (\d*), (\d*)(, [\.\d]*)?\)/);
    if (match && match[1] && match[2] && match[3]) {
        return !(match[1] === match[2] && match[2] === match[3]);
    }
    return true;
}
function getWaveColor(node) {
    return (getComputedStyle(node).getPropertyValue('border-top-color') || // Firefox Compatible
        getComputedStyle(node).getPropertyValue('border-color') ||
        getComputedStyle(node).getPropertyValue('background-color'));
}
function resetEffect(node) {
    node.removeAttribute(attributeName);
}
function isHidden(element) {
    if (process.env.NODE_ENV === 'test') {
        return false;
    }
    return !element || element.offsetParent === null;
}
function default_1(node, isEnable) {
    if (node.tagName === 'INPUT' || isHidden(node)) {
        return;
    }
    if (!isEnable)
        return {};
    var clickWaveTimeoutId = null;
    var onClick = function () {
        resetEffect(node);
        var waveColor = getWaveColor(node);
        clickWaveTimeoutId = window.setTimeout(function () {
            styleForPesudo = styleForPesudo || document.createElement('style');
            node.setAttribute(attributeName, 'true');
            if (waveColor &&
                waveColor !== '#ffffff' &&
                waveColor !== 'rgb(255, 255, 255)' &&
                isNotGrey(waveColor) &&
                !/rgba\(\d*, \d*, \d*, 0\)/.test(waveColor) && // any transparent rgba color
                waveColor !== 'transparent') {
                styleForPesudo.innerHTML = "[ant-click-animating-without-extra-node]:after { --antd-wave-shadow-color:" + waveColor + ";  }";
                if (!document.body.contains(styleForPesudo)) {
                    document.body.appendChild(styleForPesudo);
                }
            }
        }, 0);
    };
    node.addEventListener('click', onClick, true);
    return {
        destory: function () {
            node.removeEventListener('click', onClick, true);
            clearTimeout(clickWaveTimeoutId);
        },
    };
}
exports.default = default_1;
